<?php
/*
 * You may not change or alter any portion of this comment or credits
 * of supporting developers from this source code or any supporting source code
 * which is considered copyrighted (c) material of the original comment or credit authors.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

/**
 * @copyright    {@link https://xoops.org/ XOOPS Project}
 * @license      {@link https://www.gnu.org/licenses/gpl-2.0.html GNU GPL 2 or later}
 * @package
 * @since
 * @author       XOOPS Development Team
 */

use XoopsModules\Toyline\{Helper
};

/** @var Helper $helper */

require dirname(__DIR__, 2) . '/mainfile.php';
require XOOPS_ROOT_PATH . '/header.php';

require __DIR__ . '/preloads/autoloader.php';

//$moduleDirName = basename(__DIR__);

$helper        = Helper::getInstance();
$moduleDirName = $helper->getDirname();

$myts = \MyTextSanitizer::getInstance();

if (!isset($GLOBALS['xoTheme']) || !is_object($GLOBALS['xoTheme'])) {
    require $GLOBALS['xoops']->path('class/theme.php');
    $GLOBALS['xoTheme'] = new \xos_opal_Theme();
}

//Handlers
//$XXXHandler = xoops_getModuleHandler('XXX', $moduleDirName);

// Load language files
$helper->loadLanguage('main');

if (!isset($GLOBALS['xoopsTpl']) || !($GLOBALS['xoopsTpl'] instanceof XoopsTpl)) {
    require $GLOBALS['xoops']->path('class/template.php');
    $xoopsTpl = new XoopsTpl();
}

$GLOBALS['mydirname'] = basename(__DIR__);
require_once $helper->path('include/read_configs.php');
require_once $helper->path('include/get_perms.php');

/** @var \XoopsModuleHandler $moduleHandler */
$moduleHandler                  = xoops_getHandler('module');
/** @var \XoopsConfigHandler $configHandler */
$configHandler                  = xoops_getHandler('config');
$GLOBALS['toylineModule']       = $moduleHandler->getByDirname($GLOBALS['mydirname']);
$GLOBALS['toylineModuleConfig'] = $configHandler->getConfigList($GLOBALS['toylineModule']->getVar('mid'));
$GLOBALS['toyline_mid']         = $GLOBALS['toylineModule']->getVar('mid');
$GLOBALS['photos_dir']          = XOOPS_ROOT_PATH . $helper->getConfig('toyline_photospath');
$GLOBALS['thumbs_dir']          = XOOPS_ROOT_PATH . $helper->getConfig('toyline_thumbspath');
$GLOBALS['photos_url']          = XOOPS_URL . $helper->getConfig('toyline_photospath');
$GLOBALS['thumbs_url']          = XOOPS_URL . $helper->getConfig('toyline_thumbspath');

xoops_load('pagenav');
xoops_load('xoopslists');
xoops_load('xoopsformloader');

require_once $GLOBALS['xoops']->path('class/xoopsmailer.php');
require_once $GLOBALS['xoops']->path('class/tree.php');

$catHandler         = $helper->getHandler('Category');
$cats               = $catHandler->getObjects(null, true);
$GLOBALS['cattree'] = new \XoopsObjectTree($cats, 'cid', 'pid', 0);

if ($helper->getConfig('tag')) {
    require_once $GLOBALS['xoops']->path('modules/tag/include/formtag.php');
}

//gets values from module Preferences, e.g. 'toyline_viewcattype'
extract($GLOBALS['toylineModuleConfig']);

if (!isset($GLOBALS['xoopsTpl']) || !is_object($GLOBALS['xoopsTpl'])) {
    require_once XOOPS_ROOT_PATH . '/class/template.php';
    $GLOBALS['xoopsTpl'] = new \XoopsTpl();
}

require_once $helper->path('include/assign_globals.php');
