<?php

use XoopsModules\Toyline\{
    Helper,
    Utility
};
/** @var Helper $helper */

$helper = Helper::getInstance();

$GLOBALS['mydirname'] = basename(dirname(__DIR__));
if (preg_match('/^toyline(\d*)$/', $GLOBALS['mydirname'], $regs)) {
    $GLOBALS['toyline_number'] = $regs[1];
} else {
    exit('invalid dirname of toyline: ' . htmlspecialchars($GLOBALS['mydirname'], ENT_QUOTES | ENT_HTML5));
}

global $xoopsConfig, $xoopsDB, $xoopsUser;
/** @var \XoopsModuleHandler $moduleHandler */
$moduleHandler = xoops_getHandler('module');
$module        = $moduleHandler->getByDirname($GLOBALS['mydirname']);

// module information
$GLOBALS['mod_url']       = XOOPS_URL . "/modules/{$GLOBALS['mydirname']}";
$GLOBALS['mod_path']      = XOOPS_ROOT_PATH . "/modules/{$GLOBALS['mydirname']}";
$GLOBALS['mod_copyright'] = "<a href='https://xoops.org/'><strong>Toyline-P " . $module->getInfo('version') . ' by XOOPS</strong></a>';

// global language file
xoops_loadLanguage('toyline_constants', $GLOBALS['mydirname']);

// read from xoops_config
// get my mid
//$moduleHandler            = xoops_getHandler('module');
$GLOBALS['toylineModule'] = $moduleHandler->getByDirname($GLOBALS['mydirname']);
if (is_object($GLOBALS['toylineModule'])) {
    $GLOBALS['toyline_mid'] = $GLOBALS[$GLOBALS['mydirname'] . 'Module']->getVar('mid');
    $configHandler          = xoops_getHandler('config');
    // read configs from xoops_config directly
    $GLOBALS['toylineModuleConfig'] = $configHandler->getConfigList($GLOBALS['toyline_mid']);
    extract($GLOBALS['toylineModuleConfig']);
}

// User Informations
if (empty($GLOBALS['xoopsUser'])) {
    $my_uid  = 0;
    $isadmin = false;
} else {
    $my_uid  = $GLOBALS['xoopsUser']->uid();
    $isadmin = $GLOBALS['xoopsUser']->isAdmin($GLOBALS['toyline_mid']);
}

// Value Check
if (isset($GLOBALS['toyline_addposts'])) {
    $GLOBALS['toyline_addposts'] = (int)$GLOBALS['toyline_addposts'];
} else {
    $GLOBALS['toyline_addposts'] = 0;
}
if ($GLOBALS['toyline_addposts'] < 0) {
    $GLOBALS['toyline_addposts'] = 0;
}

// Path to Main Photo & Thumbnail ;
if (isset($GLOBALS['toyline_photospath'])) {
    if (0x2f != ord($GLOBALS['toyline_photospath'])) {
        $GLOBALS['toyline_photospath'] = DS . $GLOBALS['toyline_photospath'];
    }
} else {
    $GLOBALS['toyline_photospath'] = '/uploads/photos/';
}
if (isset($GLOBALS['toyline_thumbspath'])) {
    if (0x2f != ord($GLOBALS['toyline_thumbspath'])) {
        $GLOBALS['toyline_thumbspath'] = DS . $GLOBALS['toyline_thumbspath'];
    }
} else {
    $GLOBALS['toyline_thumbspath'] = '/uploads/thumbs/';
}
$photos_dir = XOOPS_ROOT_PATH . $GLOBALS['toyline_photospath'];
$photos_url = XOOPS_URL . $GLOBALS['toyline_photospath'];
if (isset($GLOBALS['toyline_makethumb'])) {
    $thumbs_dir = XOOPS_ROOT_PATH . $GLOBALS['toyline_thumbspath'];
    $thumbs_url = XOOPS_URL . $GLOBALS['toyline_thumbspath'];
} else {
    $thumbs_dir = $photos_dir;
    $thumbs_url = $photos_url;
}

// DB table name
$GLOBALS['table_photos']   = "{$GLOBALS['mydirname']}_photos";
$GLOBALS['table_cat']      = "{$GLOBALS['mydirname']}_cat";
$GLOBALS['table_text']     = "{$GLOBALS['mydirname']}_text";
$GLOBALS['table_votedata'] = "{$GLOBALS['mydirname']}_votedata";
$GLOBALS['table_comments'] = 'xoopscomments';

// Pipe environment check
if (isset($GLOBALS['toyline_imagingpipe'])) {
    if ($GLOBALS['toyline_imagingpipe'] || function_exists('imagerotate')) {
        $GLOBALS['toyline_canrotate'] = true;
    } else {
        $GLOBALS['toyline_canrotate'] = false;
    }
}
if (isset($GLOBALS['toyline_imagingpipe'])) {
    if ($GLOBALS['toyline_imagingpipe'] || $GLOBALS['toyline_forcegd2']) {
        $GLOBALS['toyline_canresize'] = true;
    } else {
        $GLOBALS['toyline_canresize'] = false;
    }
}
// Normal Extensions of Image
$GLOBALS['toyline_normal_exts'] = ['jpg', 'jpeg', 'gif', 'png'];

// Allowed extensions & MIME types
if (empty($GLOBALS['toyline_allowedexts'])) {
    $GLOBALS['array_allowed_exts'] = $GLOBALS['toyline_normal_exts'];
} else {
    $GLOBALS['array_allowed_exts'] = explode('|', $GLOBALS['toyline_allowedexts']);
}
if (empty($GLOBALS['toyline_allowedmime'])) {
    $GLOBALS['array_allowed_mimetypes'] = [];
} else {
    $GLOBALS['array_allowed_mimetypes'] = explode('|', $GLOBALS['toyline_allowedmime']);
}
